org.apache.commons.collections4.bag

## Class SynchronizedBag<E>

- java.lang.Object
- - org.apache.commons.collections4.collection.SynchronizedCollection<E>
  - - org.apache.commons.collections4.bag.SynchronizedBag<E>

- Type Parameters:
    `E` - the type of elements in this bag
  All Implemented Interfaces:
    Serializable, Iterable<E>, Collection<E>, Bag<E>
  Direct Known Subclasses:
    SynchronizedSortedBag

      public class SynchronizedBag<E>
      extends SynchronizedCollection<E>
      implements Bag<E>

  Decorates another `Bag` to synchronize its behaviour for a multi-threaded environment.

  Methods are synchronized, then forwarded to the decorated bag. Iterators must be separately synchronized around the loop.

  This class is Serializable from Commons Collections 3.1.

  Since:
    3.0
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.commons.collections4.collection.SynchronizedCollection

      `lock`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `SynchronizedBag(Bag<E> bag)` Constructor that wraps (not copies).
    `protected` | `SynchronizedBag(Bag<E> bag, Object lock)` Constructor that wraps (not copies).

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `add(E object, int count)` Adds `nCopies` copies of the specified object to the Bag.
    `boolean` | `equals(Object object)`
    `protected Bag<E>` | `getBag()` Gets the bag being decorated.
    `int` | `getCount(Object object)` Returns the number of occurrences (cardinality) of the given object currently in the bag.
    `int` | `hashCode()`
    `boolean` | `remove(Object object, int count)` Removes `nCopies` copies of the specified object from the Bag.
    `static <E> SynchronizedBag<E>` | `synchronizedBag(Bag<E> bag)` Factory method to create a synchronized bag.
    `Set<E>` | `uniqueSet()` Returns a `Set` of unique elements in the Bag.

    - ### Methods inherited from class org.apache.commons.collections4.collection.SynchronizedCollection

      `add, addAll, clear, contains, containsAll, decorated, isEmpty, iterator, remove, removeAll, removeIf, retainAll, size, synchronizedCollection, toArray, toArray, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.apache.commons.collections4.Bag

      `add, containsAll, iterator, remove, removeAll, retainAll, size`

    - ### Methods inherited from interface java.util.Collection

      `addAll, clear, contains, isEmpty, parallelStream, removeIf, spliterator, stream, toArray, toArray`

    - ### Methods inherited from interface java.lang.Iterable

      `forEach`

- - ### Constructor Detail

    - #### SynchronizedBag

          protected SynchronizedBag(Bag<E> bag)

      Constructor that wraps (not copies).
      Parameters:
        `bag` - the bag to decorate, must not be null
      Throws:
        `NullPointerException` - if bag is null

    - #### SynchronizedBag

          protected SynchronizedBag(Bag<E> bag,
                                    Object lock)

      Constructor that wraps (not copies).
      Parameters:
        `bag` - the bag to decorate, must not be null
        `lock` - the lock to use, must not be null
      Throws:
        `NullPointerException` - if bag or lock is null

  - ### Method Detail

    - #### synchronizedBag

          public static <E> SynchronizedBag<E> synchronizedBag(Bag<E> bag)

      Factory method to create a synchronized bag.
      Type Parameters:
        `E` - the type of the elements in the bag
      Parameters:
        `bag` - the bag to decorate, must not be null
      Returns:
        a new synchronized Bag
      Throws:
        `NullPointerException` - if bag is null
      Since:
        4.0

    - #### getBag

          protected Bag<E> getBag()

      Gets the bag being decorated.
      Returns:
        the decorated bag

    - #### equals

          public boolean equals(Object object)

      Specified by:
        `equals` in interface `Collection<E>`
      Overrides:
        `equals` in class `SynchronizedCollection<E>`

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in interface `Collection<E>`
      Overrides:
        `hashCode` in class `SynchronizedCollection<E>`

    - #### add

          public boolean add(E object,
                             int count)

      Description copied from interface: `Bag`
      Adds `nCopies` copies of the specified object to the Bag.

      If the object is already in the `Bag.uniqueSet()` then increment its count as reported by `Bag.getCount(Object)`. Otherwise add it to the `Bag.uniqueSet()` and report its count as `nCopies`.

      Specified by:
        `add` in interface `Bag<E>`
      Parameters:
        `object` - the object to add
        `count` - the number of copies to add
      Returns:
        `true` if the object was not already in the `uniqueSet`

    - #### remove

          public boolean remove(Object object,
                                int count)

      Description copied from interface: `Bag`
      Removes `nCopies` copies of the specified object from the Bag.

      If the number of copies to remove is greater than the actual number of copies in the Bag, no error is thrown.

      Specified by:
        `remove` in interface `Bag<E>`
      Parameters:
        `object` - the object to remove
        `count` - the number of copies to remove
      Returns:
        `true` if this call changed the collection

    - #### uniqueSet

          public Set<E> uniqueSet()

      Description copied from interface: `Bag`
      Returns a `Set` of unique elements in the Bag.

      Uniqueness constraints are the same as those in `Set`.

      Specified by:
        `uniqueSet` in interface `Bag<E>`
      Returns:
        the Set of unique Bag elements

    - #### getCount

          public int getCount(Object object)

      Description copied from interface: `Bag`
      Returns the number of occurrences (cardinality) of the given object currently in the bag. If the object does not exist in the bag, return 0.
      Specified by:
        `getCount` in interface `Bag<E>`
      Parameters:
        `object` - the object to search for
      Returns:
        the number of occurrences of the object, zero if not found

Copyright © 2001–2019 The Apache Software Foundation. All rights reserved.